<template>
  <div class="component-upload-image">
    <el-upload
      name="file"
      ref="upload"
      :list-type="listType"
      :file-list="fileList"
      :action="uploadImgUrl"
      :on-success="handleUploadSuccess"
      :on-error="handleUploadError"
      :before-upload="handleBeforeUpload"
      :limit="limit"
      :on-exceed="handleExceed"
      :on-remove="handleRemove"
      :show-file-list="showFileList"
      :headers="headers"
      :on-preview="handlePictureCardPreview"
      :on-progress="handleProgress"
      :class="{ hide: fileList.length >= limit }"
      multiple
    >
      <slot name="button"> </slot>
    </el-upload>
    <!-- 上传提示 -->
    <div class="el-upload__tip" v-if="showTip">
      请上传
      <template v-if="fileSize">
        大小不超过 <b style="color: #f56c6c">{{ fileSize }}MB</b>
      </template>
      <template v-if="fileType">
        格式为 <b style="color: #f56c6c">{{ fileType.join("/") }}</b>
      </template>
      的文件
    </div>

    <el-dialog v-model="dialogVisible" title="预览" width="800px" append-to-body>
      <img :src="dialogImageUrl" style="display: block; width: 300px; margin: 0 auto" />
    </el-dialog>
  </div>
</template>

<script setup>
const props = defineProps({
  modelValue: {
    type: [String, Object, Array],
    default: "",
  },
  // 图片数量限制
  limit: {
    type: Number,
    default: 5,
  },
  // 大小限制(MB)
  fileSize: {
    type: Number,
    default: 5,
  },
  // 文件类型, 例如['png', 'jpg', 'jpeg']
  fileType: {
    type: Array,
    default: () => ["png", "jpg", "jpeg", "svg"],
  },
  // 是否显示提示
  isShowTip: {
    type: Boolean,
    default: true,
  },
  //文件列表的类型
  listType: {
    type: String,
    default: "picture-card",
  },
  //是否显示已上传文件列表
  showFileList: {
    type: Boolean,
    default: true,
  },
  //是否覆盖
  isCover: {
    type: Boolean,
    default: false,
  },
});

const { proxy } = getCurrentInstance();
const emit = defineEmits();
const dialogImageUrl = ref("");
const dialogVisible = ref(false);
const baseUrl = import.meta.env.VITE_APP_BASE_API;
// const uploadImgUrl = ref(import.meta.env.VITE_APP_BASE_API + "/file/upload"); // 上传的图片服务器地址
const uploadImgUrl = ref(import.meta.env.VITE_APP_BASE_API + "/service-file/upload"); // 上传的图片服务器地址
const headers = ref({ Authorization: localStorage.getItem("token725") });
const fileList = ref([]);
const showTip = computed(() => props.isShowTip && (props.fileType || props.fileSize));

// 删除图片
function handleRemove(file, files) {
  if (props.limit > 1) {
  } else {
    emit("update", listToString(fileList.value));
  }
}

// 上传成功回调
function handleUploadSuccess(res, uploadFile) {
  fileList.value.push(res.data);
  if (props.limit > 1) {
    emit("update:modelValue", fileList.value);
  } else {
    emit("update", listToString(fileList.value));
  }
  proxy.$modal.closeLoading();
}

// 上传前loading加载
function handleBeforeUpload(file) {
  let isImg = false;
  if (props.fileType.length) {
    let fileExtension = "";
    if (file.name.lastIndexOf(".") > -1) {
      fileExtension = file.name.slice(file.name.lastIndexOf(".") + 1);
    }
    isImg = props.fileType.some((type) => {
      if (file.type.indexOf(type) > -1) return true;
      if (fileExtension && fileExtension.indexOf(type) > -1) return true;
      return false;
    });
  } else {
    isImg = file.type.indexOf("image") > -1;
  }
  if (!isImg) {
    proxy.$modal.msgError(`文件格式不正确, 请上传${props.fileType.join("/")}图片格式文件!`);
    return false;
  }
  if (props.fileSize) {
    const isLt = file.size / 1024 / 1024 < props.fileSize;
    if (!isLt) {
      proxy.$modal.msgError(`上传头像图片大小不能超过 ${props.fileSize} MB!`);
      return false;
    }
  }
  proxy.$modal.loading("正在上传图片，请稍候...");
}

// 图片个数超出
function handleExceed(files) {
  if (props.isCover) {
    handleBeforeUpload(files[0]);
    fileList.value = [];
    emit("update", listToString(fileList.value));
    setTimeout(() => {
      proxy.$refs["upload"].handleStart(files[0]);
      proxy.$refs["upload"].submit();
    }, 0);
  } else {
    proxy.$modal.msgError(`上传图片数量不能超过 ${props.limit} 个!`);
  }
}

// 上传失败
function handleUploadError() {
  proxy.$modal.msgError("上传图片失败");
  proxy.$modal.closeLoading();
}

// 预览
function handlePictureCardPreview(file) {
  dialogImageUrl.value = file.url;
  dialogVisible.value = true;
}

// 对象转成指定字符串分隔
function listToString(list, separator) {
  let strs = "";
  separator = separator || ",";
  for (let i in list) {
    if (undefined !== list[i].url && list[i].url.indexOf("blob:") !== 0) {
      strs += list[i].url.replace(baseUrl, "") + separator;
    }
  }
  return strs != "" ? strs.substr(0, strs.length - 1) : "";
}

watch(
  () => props.modelValue,
  (val) => {
    if (props.limit > 1) {
      fileList.value = val;
    } else {
      fileList.value = val ? [{ name: val.split("/")[val.split("/").length - 1], url: val }] : [];
    }
  },
  { deep: false, immediate: false }
);

onMounted(() => {
  if (props.modelValue) {
    fileList.value = props.limit > 1 ? props.modelValue : [{ name: props.modelValue.split("/")[props.modelValue.split("/").length - 1], url: props.modelValue }];
  }
});
</script>

<style scoped lang="scss">
// .el-upload--picture-card 控制加号部分
:deep(.hide .el-upload--picture-card) {
  display: none;
}
</style>
